import Vue from 'vue'
import axios from 'axios'
import store from '@/store'
import { VueAxios } from './axios'
import {Modal, notification} from 'ant-design-vue'
import { ACCESS_TOKEN } from "@/store/mutation-types"
import { serialize } from '@/utils/util'

//获取当前环境
const env = process.env.NODE_ENV;

let api = "/" + window.wsPackName;
if(env === 'development'){
  //测试环境默认添加前缀
  api = '/api/' + window.wsPackName;
}
// 创建 axios 实例
const service = axios.create({
  baseURL: api, // api base_url
  //baseURL:'/api/',
  timeout: 20000 // 请求超时时间
})

const err = (error) => {
  if (error.response) {
    let data = {}
    if(typeof error.response.data =="object") {
      data = error.response.data
    }
    const token = Vue.ls.get(ACCESS_TOKEN)
    console.log("------异常响应------",token) ;console.log("------异常响应------")
    // console.log("------异常响应------",error.response.status)
    switch (error.response.status) {
      case 403:
        notification.error({ message: '系统提示', description: '拒绝访问',duration: 4})
        break
      case 401:
        //notification.error({ message: '系统提示', description:'Token失效，请重新登录!',duration: 4})
        if(token && data.message=="token验证失败"){
          // update-begin- --- author:scott ------ date:20190225 ---- for:Token失效采用弹框模式，不直接跳转----
          // store.dispatch('Logout').then(() => {
          //     window.location.reload()
          // })
          notification.error({ message: '系统提示', description:'很抱歉，登录已过期，请重新登录!',duration: 4})
          // setTimeout(()=>{
          store.dispatch('Logout').then(() => {
            Vue.ls.remove(ACCESS_TOKEN)
            window.location.reload()
          })
          // },300)
          /*Modal.error({
            title: '登录已过期',
            content: '很抱歉，登录已过期，请重新登录',
            okText: '重新登录',
            mask: false,
            onOk: () => {
              store.dispatch('Logout').then(() => {
                Vue.ls.remove(ACCESS_TOKEN)
                window.location.reload()
              })
            }
          })*/
          // update-end- --- author:scott ------ date:20190225 ---- for:Token失效采用弹框模式，不直接跳转----
        }
        break
      case 404:
        notification.error({ message: '系统提示', description:'很抱歉，资源未找到!',duration: 4})
        break
      case 500:
        notification.error({ message: '系统提示', description: '请求失败'})
        break
      case 504:
        notification.error({ message: '系统提示', description: '网络超时'})
        break

      default:
        notification.error({
          message: '系统提示',
          description: data.message,
          duration: 4
        })
        break
    }
  }
  return Promise.reject(error)
};

// request interceptor
service.interceptors.request.use(config => {
  const path = location.hash.substr(1);
  let publicKey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCAcsbUyeRD2lQGPEnu5LbXOL2lycUJwK/8BsoZD3b932l4JehAvOKR/YNzs6EG4gnZ7gaXLCnWbE5kB1wuUooo6bv8fSAg0W5QmM1TH8zaIImdAaN6c8mw5dUS/2VJ/2GHI54R1NJziX9VHecpf2DrHnWngETsNytmXaVl3JiXywIDAQAB";
  let encrypt = new window.JSEncrypt();
  encrypt.setPublicKey(publicKey);
  config.headers[ 'security'] = encrypt.encryptLong(path);
console.log(config)
    if(config.url.indexOf('school-center-ui.json')!= -1){
        config.baseURL =''
    }
  const token = Vue.ls.get(ACCESS_TOKEN)
  if (token) {
    config.headers[ 'Authorization' ] = token // 让每个请求携带自定义 token 请根据实际情况自行修改
  }

  if(!config.headers[ 'Content-Type' ]){
    //序列化
    config.headers[ 'Content-Type' ] = 'application/x-www-form-urlencoded'
    if(config.data){
      config.data = serialize(config.data);
      delete config.data.serialize;
    }
  }

  if(config.method=='get'){
    config.params = {
      _t: Date.parse(new Date())/1000,
      ...config.params
    }
  }
  return config
},(error) => {
  return Promise.reject(error)
})

// response interceptor
service.interceptors.response.use((response) => {
  return response.data
}, err)

const installer = {
  vm: {},
  install (Vue, router = {}) {
    Vue.use(VueAxios, router, service)
  }
}

export {
  installer as VueAxios,
  service as axios
}
